# Library documentation

## [States](@id lib_states)
```@docs
FiniteMPS
InfiniteMPS
WindowMPS
MPSMultiline
```

## Operators
```@docs
SparseMPO
DenseMPO
MPOHamiltonian
```

## Environments
```@docs
MPSKit.AbstractInfEnv
MPSKit.PerMPOInfEnv
MPSKit.MPOHamInfEnv
MPSKit.FinEnv
MPSKit.IDMRGEnvs
```

## Generic actions
```@docs
∂C
∂∂C
∂AC
∂∂AC
∂AC2
∂∂AC2

c_proj
ac_proj
ac2_proj

expectation_value
```

## Algorithms
```@docs
find_groundstate
timestep
leading_boundary
dynamicaldmrg
changebonds
excitations
approximate
```

### [Groundstate algorithms](@id lib_gs_alg)
```@docs
VUMPS
IDMRG1
IDMRG2
DMRG
DMRG2
GradientGrassmann
```

### [Time evolution algorithms](@id lib_time_alg)
```@docs
TDVP
TDVP2
TaylorCluster
WII
```

### [Leading boundary algorithms](@id lib_bound_alg)
```@docs
VUMPS
GradientGrassmann
```

### [Bond change algorithms](@id lib_bc_alg)
```@docs
OptimalExpand
RandExpand
VUMPSSvdCut
SvdCut
```

### [Excitations]
```@docs
QuasiparticleAnsatz
FiniteExcited
```
